unit Unit_Exemple;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, Unit_Sys_Exemple, ShellAPI; //Ne pas oublier ShellAPI

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Edit3: TEdit;
    GroupBox3: TGroupBox;
    Button3: TButton;
    ComboBox1: TComboBox;
    GroupBox4: TGroupBox;
    ComboBox2: TComboBox;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GroupBox1Enter(Sender: TObject);
    procedure GroupBox1Exit(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  CurrentExtension:TExtensions;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
if OpenDialog1.Execute then
  Edit1.Text:=OpenDialog1.FileName;
end;

procedure TForm1.Button2Click(Sender: TObject);
var Path:String;
begin
Path:=Edit1.Text;
SelectDirectory('Slectionner un dossier :','',Path);
Edit1.Text:=Path;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
ComboBox2.Items.Assign(GetShow);
ComboBox2.ItemIndex:=0;
end;

procedure TForm1.GroupBox1Enter(Sender: TObject);
begin
Edit2.Enabled:=True;
Edit3.Enabled:=True;
ComboBox1.Enabled:=True;
ComboBox2.Enabled:=True;
Button3.Enabled:=True;
end;

procedure TForm1.GroupBox1Exit(Sender: TObject);
begin
if Edit1.Text<>'' then
  CurrentExtension:=GetExtension(Edit1.Text)
else
  begin
  Edit2.Enabled:=False;
  Edit3.Enabled:=False;
  ComboBox1.Enabled:=False;
  ComboBox2.Enabled:=False;
  Button3.Enabled:=False;
  Exit;
  end;
ComboBox1.Items.Assign(GetActions(CurrentExtension,French));
ComboBox1.ItemIndex:=0;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
ShellExecute(Handle,
             PChar(GetActionString(GetSelectedAction(ComboBox1.Text,French))), //Ne pas oublier PChar()
             PChar(Edit1.Text),
             PChar(Edit2.Text),
             PChar(Edit3.Text),
             GetSWShow(GetSelectedShow(ComboBox2.Text)));
end;

end.
