unit Unit_ExempleAnnexe1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Registry, FileCtrl, ShellAPI; //Ne pas oublier ShellAPI

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    GroupBox2: TGroupBox;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

const CompilatorName='dcc32.exe';

implementation

{$R *.dfm}

procedure TForm1.Button3Click(Sender: TObject);
begin
//Il est maintenant trs simple de compiler un projet
if OpenDialog1.Execute then
  ShellExecute(Handle,'Compile',PChar(OpenDialog1.FileName),nil,nil,SW_SHOW);
end;

procedure Error;
begin
MessageDlg('Erreur lors de l''ajout de l''opration.',mtError,[mbOk],0);
end;

function GetDprKey:String;
var Registry:TRegistry;
    DprName:String;
begin
Registry:=TRegistry.Create;
  try
    with Registry do
      begin
      //Changement de cl racine
      RootKey:=HKEY_CLASSES_ROOT;
      //Ouvertur de la cl .dpr
      if not OpenKey('\.dpr',False) then
        Error
      else
        begin
        DprName:=ReadString('');
        //Lecture de la valeur par dfaut avec ReadString('')
        if not OpenKey('\'+DprName+'\Shell',False) then
          Error
        else
        //Renvoie la cl Shell
          Result:='\'+DprName+'\Shell';
        end;
      end;
  finally
    Registry.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var CompilatorPath,KeyDpr:String;
    Registry:TRegistry;
begin
SelectDirectory('Slectionner le rpertoire Bin de Delphi (Borland\DelphiX\Bin) :','',CompilatorPath);
if FileExists(CompilatorPath+'\'+CompilatorName) then
  begin
  KeyDpr:=GetDprKey;
  Registry:=TRegistry.Create;
    try
      with Registry do
        begin
        //Changement de cl racine
        RootKey:=HKEY_CLASSES_ROOT;
        OpenKey(KeyDpr,False);
        //Cration cl "Compile"
        OpenKey(KeyDpr+'\Compile',True);
        //Ecriture du menu d'Explorer
        WriteString('','&Compiler');
        OpenKey(KeyDpr+'\Compile\Command',True);
        //Ecriture de l'action  raliser
        WriteString('',CompilatorPath+'\'+CompilatorName+' %1');
        end;
    finally
      Registry.Free;
    end;
  end
else
  MessageDlg('Impossible de trouver le compilateur.',mtError,[mbOk],0);
end;

procedure TForm1.Button2Click(Sender: TObject);
var KeyDpr:String;
    Registry:TRegistry;
begin
KeyDpr:=GetDprKey;
Registry:=TRegistry.Create;
  try
    with Registry do
      begin
      //Changement de cl racine
      RootKey:=HKEY_CLASSES_ROOT;
      DeleteKey(KeyDpr+'\Compile');
      end;
  finally
    Registry.Free;
  end;
end;

end.
