unit Unit_ExemplePartie5;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellAPI; //Ne pas oublier ShellAPI

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    GroupBox3: TGroupBox;
    Button3: TButton;
    Button4: TButton;
    GroupBox4: TGroupBox;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure ExecuteNotepad(Handle: HWND; ShowMode: Integer);
begin
//ShellExecute demande un Handle, dans le cas o on aurait voulu
//ne pas ajouter de paramtre Handle  ExecuteNotepad, il aurait
//fallu crire :
//ShellExecute(Form1.Handle,'Open','Notepad',nil,nil,ShowMode);
//Car cette fonction ne faisant pas partie de la fiche, elle ne
//sait pas quel Handle utilis, il faut donc le spcifi.
ShellExecute(Handle,'Open','Notepad',nil,nil,ShowMode);
end;

procedure KillNotepad;
var Handle:HWND;
begin
//Fonction de scurit
Handle:=FindWindow('Notepad',nil);
while Handle<>0 do
  begin
  //Ferme tous les bloc-notes
  SendMessage(Handle,WM_CLOSE,0,0);
  //Cherche une fentre Bloc-Notes ouverte
  Handle:=FindWindow('Notepad',nil);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
//Ouvre Notepad et l'affiche avec sa taille par dfaut
ExecuteNotepad(Handle,SW_SHOW);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
//Ouvre Notepad et le cache, il n'est ni visible comme fentre,
//ni visible dans la barre des tches
//ATTENTION
MessageDlg('Si vous lancez Bloc-Notes en mode cach, vous ne pourrez plus '+
'le fermer, car tant invisible,  moins de faire Ctrl-Alt-Suppr.'#10#13'C''est pourquoi, vous '+
'pouvez utiliser le bouton "Fermer Bloc-Notes" qui fermera l''application '+
'mme si elle est cache.'#13#10'Mais mme en cas d''oubli, tous les Bloc-Notes seront '+
'ferms  la fermeture de cet exemple.',mtWarning,[mbOk],0);
//ATTENTION
ExecuteNotepad(Handle,SW_HIDE);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
//Ouvre Notepad et le maximise
ExecuteNotepad(Handle,SW_MAXIMIZE);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
//Ouvre Notepad et le minimise
ExecuteNotepad(Handle,SW_MINIMIZE);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
//Ouvre Notepad mais ne l'active pas
ExecuteNotepad(Handle,SW_SHOWNA);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
//Ouvre Notepad, le rduit mais ne l'active pas
ExecuteNotepad(Handle,SW_SHOWMINNOACTIVE);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
//Fermeture de tous les Bloc-Notes ouvert
KillNotepad;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//Fermeture de tous les Bloc-Notes ouvert
KillNotepad;
end;

end.
